--[[
Filename: Reaper.lua
Author  : Smashed - Bladefist
]]--

Reaper_Version = "v"..GetAddOnMetadata("Reaper", "Version");

RFCC="|cffff2020";
WFCC="|cffffffff";
NFCC="|cffffd200";
DFCC="|cff888888";
GFCC="|cff00ff00";
BFCC="|cff0000ff";
YFCC="|cffffff00";
OFCC="|cffff9900";

ReapMsg      = "[REAPER]"..Reaper_Version..": ";
ReapColorMsg = RFCC.."[REAPER]"..Reaper_Version..": "..YFCC;

function round(what, precision)
   return math.floor(what*math.pow(10,precision)+0.5) / math.pow(10,precision)
end


function RPrint(a)  DEFAULT_CHAT_FRAME:AddMessage(a); end

function RInform(a)
    DEFAULT_CHAT_FRAME:AddMessage(RFCC.."REAPER >> "..YFCC..a);
end

function RTell(player,msg) RMsg(player,msg,"WHISPER"); end
function RMsg(player,msg,where) SendChatMessage(msg, where, GetDefaultLanguage("player"), player); end

function Reaper_OnLoad(self)
    -- Register Slash Commands
    SLASH_Reaper1 = "/reaper";
    SLASH_Reaper2 = "/rp";
    SlashCmdList["Reaper"] = function(msg) Reaper_CommandHandler(msg); end
    -- Register for Events
    self:RegisterEvent("VARIABLES_LOADED");
    self:RegisterEvent("TRADE_SKILL_SHOW");
    self:RegisterEvent("CRAFT_SHOW");
    self:RegisterEvent("UNIT_INVENTORY_CHANGED");
    self:RegisterEvent("PET_ATTACK_START");
    self:RegisterEvent("PET_ATTACK_STOP");
    self:RegisterEvent("UNIT_HAPPINESS");
    self:RegisterEvent("CHAT_MSG_SYSTEM");
    self:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN");
    self:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE");
    self:RegisterEvent("CHAT_MSG_COMBAT");
    self:RegisterEvent("DUEL_FINISHED");
    self:RegisterEvent("DUEL_REQUESTED");
    self:RegisterEvent("PLAYER_LEAVE_COMBAT");
    self:RegisterEvent("PLAYER_LEVEL_UP");
    self:RegisterEvent("PLAYER_LOGOUT");
    self:RegisterEvent("UI_INFO_MESSAGE");
    self:RegisterEvent("CHAT_MSG");
    self:RegisterEvent("CHAT_MSG_WHISPER");
    self:RegisterEvent("CHAT_MSG_GUILD");
    self:RegisterEvent("CHAT_MSG_PARTY");
    self:RegisterEvent("CHAT_MSG_COMBAT_MISC_INFO");
    self:RegisterEvent("PLAYER_DEAD");
    self:RegisterEvent("CHAT_MSG_COMBAT_LOG_ERROR");
    self:RegisterEvent("PLAYER_ENTER_COMBAT");
    self:RegisterEvent("PLAYER_LEAVE_COMBAT");

    self:RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS");
    self:RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_PARTY_MISSES");
    self:RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS");
    self:RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_SELF_MISSES");
    self:RegisterEvent("CHAT_MSG_COMBAT_SELF_HITS");
    self:RegisterEvent("CHAT_MSG_COMBAT_SELF_MISSES");
    self:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");
    self:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE");
    -- self:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE");
end


function Reaper_OnEvent(self, event, ...)
    local arg1, arg2 = ...;

------------------------------------[Reset some shit ]
    narg=nil; narg={};
    if(arg1~=nil) then
        numarg=0;
        for word in string.gmatch(arg1, "%w+") do
            narg[numarg]=strlower(word);
            if(narg[numarg]=="") then narg[numarg]=nil; numarg=numarg-1; end
            numarg=numarg+1;
        end
    end


------------------------------------[Save Variables  ]
    if(event=="VARIABLES_LOADED") then

	    if( not ReaperProfile ) then ReaperProfile={}; end
	    if( not ReaperProfile[GetRealmName()] ) then ReaperProfile[GetRealmName()]={}; end
	    if( not ReaperProfile[GetRealmName()][UnitName("player")] ) then ReaperProfile[GetRealmName()][UnitName("player")]={}; end
    	if( not rpdb ) then rpdb = ReaperProfile[GetRealmName()][UnitName("player")]; end
	    if(rpdb) then

	        if(rpdb.debugreaper==nil) then rpdb.debugreaper = false; end

            rpdb["Version"]	= Reaper_Version;
            rpdb["Name"]		= UnitName("player");
            rpdb["Server"]	= GetRealmName();
            rpdb["Locale"]	= GetLocale();
            rpdb["Race"],
            rpdb["RaceEn"]    =UnitRace("player")
            rpdb["Class"],
            rpdb["ClassEn"]   =UnitClass("player");
            rpdb["FactionEn"],
            rpdb["Faction"]   =UnitFactionGroup("player");
            rpdb.Enabled      = true;
            rpdb.Equipment    = true;
            rpdb.Items        = true;

            if(rpdb.Bag==nil) then rpdb.Bag = {}; end

		    rpdb.Bag[0]       = false;
		    rpdb.Bag[1]       = false;
		    rpdb.Bag[2]       = false;
		    rpdb.Bag[3]       = false;
		    rpdb.Bag[4]       = false;
		    rpdb.Bag[5]       = false;
		    rpdb.Bag[6]       = false;
		    rpdb.Bag[7]       = false;
		    rpdb.Bag[8]       = false;
		    rpdb.Bag[9]       = false;
		    rpdb.Bag[10]       = false;
		    rpdb.Bag[11]       = false;

            rpdb.TopCrit      = 0;

            if(rpdb.AutoSellItems==nil) then rpdb.AutoSellItems = {}; end


            rpxpmsg=1;
            rpxpsession=0;

            RPrint("REAPER by Smashed (Bladefist - Alliance) loaded. For help type /rp help");
            Reaper_Options_DisplayFrame_TitleText:SetText("Reaper "..Reaper_Version.." Smashed@Bladefist");
            Reaper_Options_DisplayFrame_Ding:SetChecked(rpdb.Ding);
            Reaper_Options_DisplayFrame_PxP:SetChecked(rpdb.PxP);
            Reaper_Options_DisplayFrame_AutoFollow:SetChecked(rpdb.AutoFollow);
            ReaperMinimapButton:SetPoint("CENTER", "UIParent", "BOTTOMLEFT", (rpdb.MMX or 512), (rpdb.MMY or 384));
		end

    end

------------------------------------------------------

	if(event=="PLAYER_LOGOUT") then
		rpdb.MMX, rpdb.MMY = ReaperMinimapButton:GetCenter();
	end

    if (event == "TRADE_SKILL_SHOW") then Reaper_ScanCrafts(); end
    if (event == "CRAFT_SHOW") then Reaper_ScanEnchants(); end
    if (event == "UNIT_INVENTORY_CHANGED") then end

    if(event=="CHAT_MSG_SYSTEM") then
        if(string.find(arg1, string.gsub(INSTANCE_RESET_SUCCESS, "%%s", ""))) then
            if(UnitInRaid("player")) then
                RMsg(UnitName("player"),arg1,"RAID");
            else
                if(UnitInParty("player")) then
                    RMsg(UnitName("player"),arg1,"PARTY")
                end
            end
        end
    end

    if (event=="CHAT_MSG_COMBAT_XP_GAIN")
    or (event=="CHAT_MSG_COMBAT_FACTION_CHANGE") then
        if(rpdb.PxP==1) then
            if(event=="CHAT_MSG_COMBAT_XP_GAIN") then
                for creatureName, xp in string.gmatch(arg1, "(.+) dies, you gain (%d+) experience.") do
                    if(creatureName~=nil) then

                        RMsg(UnitName("player"),creatureName.." yields "..xp.." XP ","PARTY");

                        rpxpsession = rpxpsession+xp;

                        rpxpmsg = rpxpmsg+1;

                        if(rpxpmsg > 1) then
                            rpxpmsg=1;

							rpxppct=UnitXP("player")/UnitXPMax("player")*100;

                            rpxppcts=strsplit(".",rpxppct); rpxppctf=rpxppcts[0];

                            RMsg(UnitName("player")," ("..UnitXP("player").."/"..UnitXPMax("player")..") Total session XP:"..rpxpsession,"PARTY");
                        end
                    end
                end
            end
        end
    end

    if(event=="PLAYER_LEVEL_UP") then
        if(rpdb.Ding==1) then
			msg="Ding! Level "..arg1;
			RMsg(UnitName("player"),msg,"GUILD");
        end
    end




	if(	event == "CHAT_MSG_COMBAT_SELF_HITS" or
		event == "CHAT_MSG_COMBAT_SELF_MISSES" or
		event == "CHAT_MSG_SPELL_SELF_DAMAGE" or
		event == "CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE" or
		event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE"
		) then

        RPrint("HIT!");





	end

--[[


GetGuildInfoText();
GetGuildRosterMOTD();



-----------------------------------------------------



	for spell, creatureName, damage in string.gmatch(narg[0], "Your (.+) crits (.+) for (%d+).") do
            if(creatureName~=nil) then

                if(rpdb.TopCrit<damage) then
                    oldtc=rpdb.TopCrit;
                    rpdb.TopCrit=damage;
                    SendChatMessage("Testing Please don't leash me! MY TOP CRIT:("..rpdb.TopCrit..") MY OLD TOP CRIT:("..oldtc..")", "GUILD", GetDefaultLanguage("player"), arg2);
                    end



                end
            end

	for creatureName, damage in string.gmatch(narg[0], "You crit (.+) for (%d+)") do
            if(creatureName~=nil) then


                if(rpdb.TopCrit<damage) then
                    oldtc=rpdb.TopCrit;
                    rpdb.TopCrit=damage;
                    SendChatMessage("Testing Please don't leash me! MY TOP CRIT:("..rpdb.TopCrit..") MY OLD TOP CRIT:("..oldtc..")", "GUILD", GetDefaultLanguage("player"), arg2);
                    end

                end
            end












-----------------------------------------------------














		for creatureName in string.gmatch(narg[0], "(.+) is afflicted by Sleep.") do
            if(creatureName~=nil) then
				if(rpdb.Enabled == true) then
					DoEmote("laugh");
					ClearTarget();
					PetPassiveMode();
					PetFollow();
					RPrint(ReapMsg..creatureName.." |cff20ff20 ZzZzZ");
					TakeScreenshot();
					ToggleAutoRun();
					end
                end
            end

		for creatureName, damage,damageType, spell in string.gmatch(narg[0], "(.+) suffers (%d+) (.+) damage from your (.+).") do
            if(creatureName~=nil) then

                end
            end
		for spell, creatureName, damage in string.gmatch(narg[0], "Your (.+) hits (.+) for (%d+).") do
            if(creatureName~=nil) then

                end
            end
		for creatureName, damage in string.gmatch(narg[0], "You hit (.+) for (%d+)") do
            if(creatureName~=nil) then

            end



	for creatureName in string.gmatch(narg[0], "You miss (.+).") do
            if(creatureName~=nil) then

                end
            end
        for creatureName in string.gmatch(narg[0], "You attack. (.+) parries.") do
            if(creatureName~=nil) then

                end
            end
		for creatureName in string.gmatch(narg[0], "You attack. (.+) evades.") do
            if(creatureName~=nil) then

                end
            end
		for creatureName in string.gmatch(narg[0], "You attack. (.+) dodges.") do
            if(creatureName~=nil) then

                end
            end
        for creatureName in string.gmatch(narg[0], "You attack. (.+) deflects.") do
            if(creatureName~=nil) then

                end
            end
		for creatureName in string.gmatch(narg[0], "You attack. (.+) blocks.") do
            if(creatureName~=nil) then

                end
            end
        for spell, creatureName in string.gmatch(narg[0], "Your (.+) was blocked by (.+).") do
            if(creatureName~=nil) then

                end
            end
		for spell, creatureName in string.gmatch(narg[0], "Your (.+) was deflected by (.+).") do
            if(creatureName~=nil) then

                end
            end
		for spell, creatureName in string.gmatch(narg[0], "Your (.+) was dodged by (.+).") do
            if(creatureName~=nil) then

                end
            end
        for spell, creatureName in string.gmatch(narg[0], "Your (.+) was evaded by (.+).") do
            if(creatureName~=nil) then

                end
            end
		for spell, creatureName in string.gmatch(narg[0], "Your (.+) is parried by (.+)") do
            if(creatureName~=nil) then

                end
            end
		for spell, creatureName in string.gmatch(narg[0], "Your (.+) was resisted by (.+).") do
            if(creatureName~=nil) then

                end
            end
        for spell, creatureName in string.gmatch(narg[0], "Your (.+) failed. (.+) is immune.") do
            if(creatureName~=nil) then

                end
            end
		for spell, creatureName in string.gmatch(narg[0], "Your (.+) missed (.+).") do
            if(creatureName~=nil) then

                end
            end
		end

        ]]--


------------------------------------[Got some whisper]

    if   ( event == "CHAT_MSG_WHISPER"  )
    or   ( event == "CHAT_MSG_GUILD"    )
    or   ( event == "CHAT_MSG_PARTY"    ) then

        if(event=="CHAT_MSG_GUILD") then where="GUILD"; end
        if(event=="CHAT_MSG_WHISPER") then where="WHISPER"; end
        if(event=="CHAT_MSG_PARTY") then where="PARTY"; end

        if (arg1==nil) then arg1="?"; end
        if (arg2==nil) then arg2="?"; end

        ------------------------------------[Reaper Help     ]
	    if((arg1=="reaper") or (arg1=="rp") or (arg1=="help")) then
            if (event == "CHAT_MSG_GUILD") then return; end
            if (event == "CHAT_MSG_PARTY") then return; end
            RTell(arg2,"By Deadline aka Dardel");
            RTell(arg2,"=[Usage]==========================================");
            RTell(arg2,"/w "..UnitName("player").." then use one of the following commands:");

            RTell(arg2,"=[Crafts]=========================================");
            RTell(arg2,"craft [search pattern].............Searches all tradeskill items");
            RTell(arg2,"craft st...........................Lists all craft subtypes");
            RTell(arg2,"mats [search pattern]..............Lists materials for craft items");
            RTell(arg2,"[craft sub type]...................Lists all items in subtype");
            RTell(arg2,"[craft sub type] [search pattern]..Searches all craft subtype");
            RTell(arg2,"order <cataloged number> [number]..Request items");
            RTell(arg2,"order <order number> cancel........Cancels item request");
            RTell(arg2,"==================================================");

            RTell(arg2,"==================================================");
            RTell(arg2,"g [search pattern].................Guild information");

            RTell(arg2,"items [search pattern].............Items on hand");
            RTell(arg2,"eq.................................Equipped items");
            RTell(arg2,"eq [slot]..........................Equipped item in slot");
            RTell(arg2,"eq [search pattern]................Searches player's equipped items");

            RTell(arg2,"==================================================");
            RTell(arg2,"help...............................This help message");
            RTell(arg2,"(note: this is beta so some functions may not be fully implemented)");
		    return;
	    end
        ------------------------------------------------------

        if( (narg[0]=="follow") and
            (event=="CHAT_MSG_PARTY") and
            (rpdb.AutoFollow==1) ) then
            FollowUnit(arg2);
        end

        if(narg[0]=="pxp") then
	    if(event == "CHAT_MSG_PARTY") then
		if(narg[1]=="off") then
			rpdb.PxP=0;
			RMsg(UnitName("player"),"(Reaper) Party XP gains turned off","PARTY");
		end
		if(narg[1]=="on") then
			rpdb.PxP=1;
		        RMsg(UnitName("player"),"(Reaper) Party XP gains turned on","PARTY");
		end
	      Reaper_Options_DisplayFrame_PxP:SetChecked(rpdb.PxP);
	    end
    end

	if(narg[0]=="craft") then
            if(narg[1]=="st") then
                RMsg(arg2,"categories of items I can make:",where);
                if(rpdb.TradeSkill) then
                    for trade, tradedb in pairs(rpdb.TradeSkill) do
                        RMsg(arg2,": "..trade.." ("..traderpdb.CurrentLevel.."/"..traderpdb.MaxLevel..")",where);
                        for category, _ in pairs(tradedb) do
                            if( (category~="MaxLevel") or (category~="CurrentLevel") ) then
                                RMsg(arg2,"Category type: "..category,where);
                            end
                        end
                    end
                end
                RMsg(arg2,": /w "..UnitName('player').." category_type [search pattern]",where);
            end
            if(narg[1]~="st") then
                RP_WCrafts(narg,arg2,where);
            end
            return;
        end

        if(narg[0]=="mats") then
            Reaper_TellMats(narg);
            return;
        end

        ------------------------------------------------------

		if(narg[0]=="eq") then
			if (event == "CHAT_MSG_GUILD") then return; end
			if (Reaper_deny()==false) then return; end
			if (rpdb.Equipment == false) then return; end
			RTell(arg2, "Items I've got equipped:");
			iHi=Reaper_GetEquippedItem("HeadSlot"); if(iHi~=nil) then
			RTell(arg2,"Head    :"..iHi); end
			iHi=Reaper_GetEquippedItem("NeckSlot"); if(iHi~=nil) then
			RTell(arg2,"Neck    :"..iHi); end
			iHi=Reaper_GetEquippedItem("ShoulderSlot"); if(iHi~=nil) then
			RTell(arg2,"Shoulder:"..iHi); end
			iHi=Reaper_GetEquippedItem("BackSlot"); if(iHi~=nil) then
			RTell(arg2,"Back    :"..iHi); end
			iHi=Reaper_GetEquippedItem("ChestSlot"); if(iHi~=nil) then
			RTell(arg2,"Chest   :"..iHi); end
			iHi=Reaper_GetEquippedItem("ShirtSlot"); if(iHi~=nil) then
			RTell(arg2,"Shirt   :"..iHi); end
			iHi=Reaper_GetEquippedItem("TabardSlot"); if(iHi~=nil) then
			RTell(arg2,"Tabard  :"..iHi); end
			iHi=Reaper_GetEquippedItem("WristSlot"); if(iHi~=nil) then
			RTell(arg2,"Wrist   :"..iHi); end
			iHi=Reaper_GetEquippedItem("HandsSlot"); if(iHi~=nil) then
			RTell(arg2,"Hands   :"..iHi); end
			iHi=Reaper_GetEquippedItem("WaistSlot");if(iHi~=nil) then
			RTell(arg2,"Waist   :"..iHi); end
			iHi=Reaper_GetEquippedItem("LegsSlot"); if(iHi~=nil) then
			RTell(arg2,"Legs    :"..iHi); end
			iHi=Reaper_GetEquippedItem("FeetSlot"); if(iHi~=nil) then
			RTell(arg2,"Feet    :"..iHi); end
			iHi=Reaper_GetEquippedItem("Finger0Slot"); if(iHi~=nil) then
			RTell(arg2,"Finger 1:"..iHi); end
			iHi=Reaper_GetEquippedItem("Finger1Slot"); if(iHi~=nil) then
			RTell(arg2,"Finger 2:"..iHi); end
			iHi=Reaper_GetEquippedItem("Trinket0Slot"); if(iHi~=nil) then
			RTell(arg2,"Trinket 1:"..iHi); end
			iHi=Reaper_GetEquippedItem("Trinket1Slot"); if(iHi~=nil) then
			RTell(arg2,"Trinket 2:"..iHi);end
			iHi=Reaper_GetEquippedItem("MainHandSlot"); if(iHi~=nil) then
			RTell(arg2,"Main Hand:"..iHi); end
			iHi=Reaper_GetEquippedItem("SecondaryHandSlot"); if(iHi~=nil) then
			RTell(arg2,"2nd Hand :"..iHi); end
			iHi=Reaper_GetEquippedItem("RangedSlot"); if(iHi~=nil) then
			RTell(arg2,"Ranged   :"..iHi); end
		end



	if (narg[0]=="items") then

      		else
			  TEXTOUT = "WHISPER";
       	end

	--if (Reaper_deny()==false) then return; end
	--if (rpdb.Items == false) then return; end
	-- if( arg3 ~=nil) then RPrint(" >> searching items for ["..arg3.."]"); end
        -- Armor Cons Container Key Misc Reagent Recipe Projectile Quiver Trade Weapon
        if (narg[1]=="potions") then narg[1]="cons"; end
			for bag= -1,11 do
				if (rpdb.Bag[bag] ~= false) then
					Gslots=GetContainerNumSlots(bag);
					for slot = 1,Gslots
					do
						iHi=GetContainerItemLink(bag,slot);
						if(iHi~=nil) then

							link=Reaper_GetLink(iHi);
							local itemName, itemLink, itemRarity, itemLevelReq, itemType, itemSubType, itemStackCount = GetItemInfo(link);
							if(itemRarity == nil) then itemRarity="Poor"; end
							if(itemRarity ==0) then itemRarity="Poor"; end
							if(itemRarity ==1) then itemRarity="Normal"; end
							if(itemRarity ==2) then itemRarity="Uncommon"; end
							if(itemRarity ==3) then itemRarity="Rare"; end
							if(itemRarity ==4) then itemRarity="Epic"; end
							if(itemRarity ==5) then itemRarity="Legendary"; end
							if(itemLevelReq==nil) then itemLevelReq="1"; end
							if(itemLevelReq < 1) then itemLevelReq="1"; end
							if(itemType==nil) then itemType="0"; end
							if(itemSubType==nil) then itemSubType="0"; end
							if(itemStackCount==nil) then itemStackCount="1"; end
							duh,count,d2,quality,read = GetContainerItemInfo(bag,slot);
							if(count==nil) then count =1; end

							if (bag==0) then message  = "Bag 1  > "..iHi;  end
							if (bag==1) then message  = "Bag 2  > "..iHi;  end
							if (bag==2) then message  = "Bag 3  > "..iHi;  end
							if (bag==3) then message  = "Bag 4  > "..iHi;  end
							if (bag==4) then message  = "Bag 5  > "..iHi; end
                            				if (bag==-1) then message = "Bank   > "..iHi; end
							if (bag==5) then message  = "Bank 1 > "..iHi;  end
							if (bag==6) then message  = "Bank 2 > "..iHi;  end
							if (bag==7) then message  = "Bank 3 > "..iHi;  end
							if (bag==8) then message  = "Bank 4 > "..iHi;  end
							if (bag==9) then message  = "Bank 5 > "..iHi;  end
							if (bag==10) then message = "Bank 6 > "..iHi;  end
                            				if (bag==11) then message = "Bank 7 > "..iHi; end

							if(count>1) then message = message.."x"..count; end

							if (narg[1]~=nil) then
                                				gfart=0;
								if (string.find(strlower(itemName),strlower(narg[1]))~=nil) then
									SendChatMessage(message.." ("..itemSubType..")", TEXTOUT, GetDefaultLanguage("player"), arg2);
                                    						gfart=1;
							    	end
                                				if (string.find(strlower(itemSubType),strlower(narg[1]))~=nil) then
                                    					if (gfart==0) then
									        SendChatMessage(message.." ("..itemSubType..")", TEXTOUT, GetDefaultLanguage("player"), arg2);
					                                end
								end
					       		else
							    SendChatMessage(message.." ("..itemSubType..")", TEXTOUT, GetDefaultLanguage("player"), arg2);
							end
						end
					end
				end
			end
		end
	end

------------------------------------------------------

------------------------------------[REAPER HELP     ]
function Reaper_ShowHelp(msg)
    RPrint("by Smashed / Bladefist --- Help:");
    RPrint("/rp show.............displays interface");
    RPrint("/rp hide.............hides interface");
    RPrint("/rp minishow.........displays minimap button");
    RPrint("/rp minihide.........hides minimap button");
    RPrint("/rp <on|off>.........turn all replies on or off");
    RPrint("/rp eq <on|off>......turn on/off equipment replies");
    RPrint("/rp items <on|off>...turn on/off items replies");
    RPrint("/rp bag <#> <on|off>.turn on/off bag # replies");

    RPrint("/rp guild <on|off>...turn on/off guild info replies");
    RPrint("/rp rs...............restack items in backpacks");
    RPrint("/rp si <#>...........links items in bag # to guild chat");
    RPrint("/rp st <#>...........links items in bag # to trade channel");
    RPrint("/rp aslist...........lists items that are on your Auto Sell list");
    RPrint("/rp asremove #.......removes an item from the auto sell list");
    RPrint("/rp asadd <item>.....adds an item (by name) to the auto sell list");
    RPrint("/rp asthresh <#>.....sets threshold for auto sell "..RFCC.."(USE WITH CAUTION!!!)");
    RPrint("  "..DFCC.."0=Poor"..WFCC.." 1=Normal"..GFCC.." 2=Uncommon"..BFCC.." 3=Rare"..OFCC.." 4=Epic"..RFCC.." 5=Legendary");
    RPrint("/rp aselist..........lists items to be excluded from auto sell");
    RPrint("/rp aseremove #......removes an item from the auto sell exclude list");
    RPrint("/rp aseadd <item>....adds an item (by name) to the auto sell exclude list");
    RPrint("/rp asethresh #......sets threshold for auto sell exclusions");
    RPrint("  "..DFCC.."0=Poor"..WFCC.." 1=Normal"..GFCC.." 2=Uncommon"..BFCC.." 3=Rare"..OFCC.." 4=Epic"..RFCC.." 5=Legendary");
    RPrint("/rp where <item search pattern> - Find items in your bag");
    RPrint("/w <player> rp - Help");
    RPrint("/w <player> items [search pattern] - list items from someone else to your chat");
    RPrint("/w <player> eq - Get users equipped items to your chat");

    RPrint("------------------------------------------------------------------------");
end
------------------------------------------------------

------------------------------------[Handle functions]

function Reaper_CommandHandler(msg)

    cmd=msg;

    for mesg,arg2 in string.gmatch(msg, "(.+) (.+)") do	msg=mesg; arg1=arg2; end
    narg=nil; narg={};
    if(msg~=nil) then
        numarg=0;
        for word in string.gmatch(cmd, "%w+") do
            narg[numarg]=strlower(word);
            if(narg[numarg]=="") then narg[numarg]=nil; numarg=numarg-1; end

			if(rpdb.debugreaper==true) then RPrint(numarg.." ["..narg[numarg].."]"); end

            numarg=numarg+1;
        end
    end

    -- Print Help
    if ( msg == "help" ) or ( msg == "" ) or ( msg == "?" ) then Reaper_ShowHelp(); return; end


--------------------------------------------------------------------------------

    if(cmd=="topcrit") then
        RPrint(rpdb.TopCrit);
    end

    if(cmd=="debug") then
        for tsname,tstable in pairs(MerchantFrame) do
            RPrint(tsname);
        end
            RPrint(MerchantFrame.selectedTab);
    end

    if(cmd=="dbf") then
        local curframe=GetMouseFocus():GetName();
        RPrint(curframe);
    end

    if(cmd=="fish") then
        FISHFORK=0;
        local spell, _, _, _, _, endTime = UnitChannelInfo("player")
            if spell then
            -- local finish = endTime/1000 - GetTime()
            RPrint(spell);
            if(spell=="Fishing") then FISHFORK=1; end
        end
        if(FISHFORK==0) then PlaySound("RaidWarning"); end
    end


--------------------------------------------------------------------------------


	if(narg[0]=="where") then
		if (narg[1]=="potions") then narg[1]="cons"; end
		for bag= -1,11 do
			Gslots=GetContainerNumSlots(bag);
			for slot = 1,Gslots
			do
				iHi=GetContainerItemLink(bag,slot);
				if(iHi~=nil) then
					link=Reaper_GetLink(iHi);
					local itemName, itemLink, itemRarity, itemLevelReq, itemType, itemSubType, itemStackCount = GetItemInfo(link);
					if(itemRarity == nil) then itemRarity="Poor"; end
					if(itemRarity ==0) then itemRarity="Poor"; end
					if(itemRarity ==1) then itemRarity="Normal"; end
					if(itemRarity ==2) then itemRarity="Uncommon"; end
					if(itemRarity ==3) then itemRarity="Rare"; end
					if(itemRarity ==4) then itemRarity="Epic"; end
					if(itemRarity ==5) then itemRarity="Legendary"; end
					if(itemLevelReq==nil) then itemLevelReq="1"; end
					if(itemLevelReq < 1) then itemLevelReq="1"; end
					if(itemType==nil) then itemType="0"; end
					if(itemSubType==nil) then itemSubType="0"; end
					if(itemStackCount==nil) then itemStackCount="1"; end
					duh,count,d2,quality,read = GetContainerItemInfo(bag,slot);
					if(count==nil) then count =1; end

					if (bag==0) then message  = "Bag 1  > "..itemName;  end
					if (bag==1) then message  = "Bag 2  > "..itemName;  end
					if (bag==2) then message  = "Bag 3  > "..itemName;  end
					if (bag==3) then message  = "Bag 4  > "..itemName;  end
					if (bag==4) then message  = "Bag 5  > "..itemName; end
					if (bag==-1) then message = "Bank   > "..itemName; end
					if (bag==5) then message  = "Bank 1 > "..itemName;  end
					if (bag==6) then message  = "Bank 2 > "..itemName;  end
					if (bag==7) then message  = "Bank 3 > "..itemName;  end
					if (bag==8) then message  = "Bank 4 > "..itemName;  end
					if (bag==9) then message  = "Bank 5 > "..itemName;  end
					if (bag==10) then message = "Bank 6 > "..itemName;  end
					if (bag==11) then message = "Bank 7 > "..itemName; end

					if(count>1) then message = message.."x"..count; end

					if (narg[1]~=nil) then
						gfart=0;
						if (string.find(strlower(itemName),strlower(narg[1]))~=nil) then
							RPrint(message);--.." ("..itemSubType..")");
							gfart=1;
						end
						if (string.find(strlower(itemSubType),strlower(narg[1]))~=nil) then
							if (gfart==0) then
								RPrint(message);--.." ("..itemSubType..")");
							end
						end
					else
						RPrint(message);--.." ("..itemSubType..")");
					end
				end
			end
		end
	end


	-- Turn Reaper On
	if(narg[0]== "on" )
	then
		rpdb.Enabled = true;
		RPrint("now turned on");
		return;
	end

	-- Turn Reaper Off
	if(narg[0]=="off" )
	then
		rpdb.Enabled = false;
		RPrint("now turned off");
		return;
	end

	-- Turn Reaper Equipment On

	if(narg[0]=="eq") then
        if(narg[1]=="off") then
		    rpdb.Equipment = false;
		    RPrint("equipment now turned off");
        else
		    rpdb.Equipment = true;
		    RPrint("equipment now turned on");
        end
		return;
	end

	-- Turn Reaper Items on or ff

	if(narg[0]=="items" ) then
        if(narg[1]=="off") then
		    rpdb.Items = false;
		    RPrint("items now turned off");
        else
            rpdb.Items = true;
            RPrint("items now turned on");
        end
		return;
	end

    -- Turn Reaper Bag on or off

    if(narg[0]=="bag") then
        bag=narg[1];
        if(narg[2]=="off") then
            rpdb.Bag[bag]=0;
            RPrint("bag "..bag.." now turned off");
        else
            rpdb.Bag[bag]=1;
            RPrint("bag "..bag.." now turned on");
        end
    end

	-- Restack inventory items
	if ( msg == "rs" )
	then
		Reaper_Restack();
		RPrint("restacked your items.");
		return;
	end

	-- Send inventory to target
	if ( msg == "si" ) then
        local toldguild=0;
        local numitems=0;
        local linetrig=0;
        local message="";
		bag=arg1;
		for slot = 1,GetContainerNumSlots(bag)
		do
			iHi=GetContainerItemLink(bag,slot);
			if(iHi~=nil) then
				link=Reaper_GetLink(iHi);
				local itemName, itemLink, itemRarity, itemLevelReq, itemType, itemSubType, itemStackCount = GetItemInfo(link);
				if(itemRarity == nil) then itemRarity="Poor"; end
				if(itemRarity ==0) then itemRarity="Poor"; end
				if(itemRarity ==1) then itemRarity="Normal"; end
				if(itemRarity ==2) then itemRarity="Uncommon"; end
				if(itemRarity ==3) then itemRarity="Rare"; end
				if(itemRarity ==4) then itemRarity="Epic"; end
				if(itemRarity ==5) then itemRarity="Legendary"; end
				if(itemLevelReq==nil) then itemLevelReq="1"; end
				if(itemLevelReq < 1) then itemLevelReq="1"; end
				if(itemType==nil) then itemType="0"; end
				if(itemSubType==nil) then itemSubType="0"; end
				if(itemStackCount==nil) then itemStackCount="1"; end
				duh,count,d2,quality,read = GetContainerItemInfo(bag,slot);
				if(count==nil) then count = 1; end
                numitems=numitems+1;
                message=message..iHi;
                if(count > 1) then message=message.."x"..count; end
                linetrig=linetrig+1;
                if(linetrig>2) then
					if(toldguild==0) then RMsg("","Anybody need/want these items:","GUILD"); toldguild=1; end
                    RMsg(UnitName("player"),message,"GUILD");
                    linetrig=0;
                    message="";
                end
			end
		end
		if(message=="") then
		else
			if(toldguild==0) then RMsg("","Anybody need/want these items:","GUILD"); toldguild=1; end
			RMsg(UnitName("player"),message,"GUILD");
		end

		if(toldguild==0) then
			RPrint("No items in that bag!");
		end
		return;
	end

	-- Send inventory to Trade Channel
	if ( msg == "st" ) then
        local numitems=0;
        local linetrig=0;
        local message="WTS ";
		bag=arg1;
		for slot = 1,GetContainerNumSlots(bag)
		do
			iHi=GetContainerItemLink(bag,slot);
			if(iHi~=nil) then
				link=Reaper_GetLink(iHi);
				local itemName, itemLink, itemRarity, itemLevelReq, itemType, itemSubType, itemStackCount = GetItemInfo(link);
				if(itemRarity == nil) then itemRarity="Poor"; end
				if(itemRarity ==0) then itemRarity="Poor"; end
				if(itemRarity ==1) then itemRarity="Normal"; end
				if(itemRarity ==2) then itemRarity="Uncommon"; end
				if(itemRarity ==3) then itemRarity="Rare"; end
				if(itemRarity ==4) then itemRarity="Epic"; end
				if(itemRarity ==5) then itemRarity="Legendary"; end
				if(itemLevelReq==nil) then itemLevelReq="1"; end
				if(itemLevelReq < 1) then itemLevelReq="1"; end
				if(itemType==nil) then itemType="0"; end
				if(itemSubType==nil) then itemSubType="0"; end
				if(itemStackCount==nil) then itemStackCount="1"; end
				duh,count,d2,quality,read = GetContainerItemInfo(bag,slot);
				if(count==nil) then count = 1; end
                numitems=numitems+1;
                message=message..iHi;
                if(count > 1) then message=message.."x"..count; end
                linetrig=linetrig+1;
                if(linetrig>2) then
                    message=message.." PST";
                    local index = GetChannelName("General") -- It finds General is a channel at index 1
                    if (index~=nil) then
                        SendChatMessage(message , "CHANNEL", nil, index);
                    end
                    linetrig=0;
                    message="";
                end
			end
		end
		if(message=="") then
		else
			SendChatMessage(message , "CHANNEL", nil, index);
		end
		return;
	end
end

function Reaper_GetLink(item)
    if(item==nil) then return nil; end
	for io,iw,ix in string.gmatch(item,"(.+)item:(.+):(.+)") do link="item:"..iw..":0"; end;
	return link;
end

function Reaper_Restack()
    local bag=0;
    local ibag=0;
    local slot=0;
	local islot=0;
	local ammo=9;
	local tbag=0;
	local tslot=0;

	for bag = 0,4
	do
        if(GetBagName(bag)~=nil) then
		    if(string.find(GetBagName(bag),"ammo")~=nil) then ammo=bag; end
		    if(string.find(GetBagName(bag),"Ammo")~=nil) then ammo=bag; end
		    if(string.find(GetBagName(bag),"quiver")~=nil) then ammo=bag; end
		    if(string.find(GetBagName(bag),"Quiver")~=nil) then ammo=bag; end
        end
	end

	for bag = 0,4
	do
		tbag=bag;
		for slot = 1,20
		do
			tslot=slot;
			if(ammo~=bag) then
				iHi=GetContainerItemLink(bag,slot);
				if(iHi==nil) then iHi="wot";
				else

					link=Reaper_GetLink(iHi);
                    if(link ~=nil) then

					    local itemName, itemLink, itemRarity, itemLevelReq, itemType, itemSubType, itemStackCount = GetItemInfo(link);
					    duh,count,d2,quality,read = GetContainerItemInfo(bag,slot);
					    if (count == itemStackCount) then

					    else
						    for ibag = 0,4
						    do
							    if(ammo~=ibag) then
								    for islot = 1,30
								    do
									    if(ibag==bag) and (islot==slot) then

									    else
										    if(GetContainerItemLink(ibag,islot)==iHi) then

                                                link=Reaper_GetLink(iHi);
                                                if(link ~= nil) then

                                                    local    itemName, itemLink, itemRarity, itemLevelReq, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(link);

											        duh,count,d2,quality,read = GetContainerItemInfo(ibag,islot);

											        if(count==itemStackCount) then

											        else
												        RPrint("Combined item "..itemName);
												        PickupContainerItem(bag,slot);

												        a_temporary_variable=3;
												        if(ibag==3) then a_temporary_variable=4; end
												        if(a_temporary_variable==ammo) then a_temporary_variable=ammo-1; end
												        Reaper_GoBag(a_temporary_variable);
												        jork=Reaper_GetSlot(iHi,a_temporary_variable);
												        if(jork~=nil) then
													        PickupContainerItem(a_temporary_variable,jork);
													        Reaper_GoBag(ibag);
												        end
                                                    end
											    end
										    end
									    end
								    end
							    end
						    end
					    end
                    end
				end
			end
		end
	end

	return false;
end

function Reaper_GoBag(bag)
	if (bag==0) then PutItemInBackpack(); end
	if (bag==1) then PutItemInBag(20); end
	if (bag==2) then PutItemInBag(21); end
	if (bag==3) then PutItemInBag(22); end
	if (bag==4) then PutItemInBag(23); end
end

function Reaper_GetSlot(itemZ,bag)
	for slot=1,20
	do
		iHi=GetContainerItemLink(bag,slot);
		if(iHi~=nil) then
			if(iHi==itemZ) then
				return slot;
			end
		end
	end
	return nil;
end

function Reaper_GetEquippedItem(slot)
	RPrint(slot);
	slotId,what=GetInventorySlotInfo(slot);
	if(slotId~=nil) then return GetInventoryItemLink("player",slotId);
	end
end

function Reaper_deny()
	if (rpdb.Enabled==false) then
		RTell(arg2,UnitName("player").." has that feature turned off. Ask them to turn it on.");
		return false;
	end
	return true;
end


--------------------------------------------------------------------------------
-- TOGGLE OPTIONS BELOW

function Reaper_Options_Toggle()
		if (Reaper_Options_DisplayFrame:IsShown()) then
			Reaper_Options_DisplayFrame:Hide();
		else
			Reaper_Options_DisplayFrame:Show();
		end
end

--------------------------------------------------------------------------------

function Reaper_Toggle_Ding()
	rpdb.Ding=Reaper_Options_DisplayFrame_Ding:GetChecked();
	if(rpdb.Ding==1) then
		RInform("Ding Guild Announce now turned on");
	else
		RInform("Ding Guild Announce now turned off");
	end
end

--------------------------------------------------------------------------------

function Reaper_Toggle_PxP()
	rpdb.PxP=Reaper_Options_DisplayFrame_PxP:GetChecked();
	if(rpdb.PxP==1) then
		RInform("Announce XP Gains to Party Chat now turned on");
	else
		RInform("Announce XP Gains to Party Chat now turned off");
	end
end

--------------------------------------------------------------------------------

function Reaper_Toggle_AutoFollow()
	rpdb.AutoFollow=Reaper_Options_DisplayFrame_AutoFollow:GetChecked();
	if(rpdb.AutoFollow==1) then
		RInform("Auto follow now turned on");
	else
		RInform("Auto follow now turned off");
	end
end


--[[

RPrint("\124c00ffffff\- "..SPELLLINK);


]]--
